Hooks:PostHook(PlayerStandard, "_check_action_primary_attack", "le_boltgrease_newstats", function(self, t, input)
	-- stripped down version of InF _check_action_primary_attack
	--
	local action_wanted = input.btn_primary_attack_state or input.btn_primary_attack_release

	if action_wanted then
	--if action_wanted and not BeardLib.Utils:FindMod("irenfist") then
		local action_forbidden = self:_is_reloading() or self:_changing_weapon() or self:_is_meleeing() or self._use_item_expire_t or self:_interacting() or self:_is_throwing_projectile() or self:_is_deploying_bipod() or self._menu_closed_fire_cooldown > 0 or self:is_switching_stances() --or self:_is_fire_disallowed(t)

		if not action_forbidden then
			--
			if self._equipped_unit then
				local weap_base = self._equipped_unit:base()
				local fire_mode = weap_base:fire_mode()
				local fire_on_release = weap_base:fire_on_release()

				-- ANIMATE FASTER
				local anim_speed_mult = 1
				-- but not during bursts
				if weap_base.in_burst_mode and not weap_base:in_burst_mode() then --
					anim_speed_mult = weap_base:fire_rate_multiplier() or 1
				end
				if weap_base._anim_speed_mult then
					anim_speed_mult = anim_speed_mult * weap_base._anim_speed_mult
				end
				if not self._state_data.in_steelsight then
					anim_speed_mult = anim_speed_mult * (weap_base._hipfire_anim_speed_mult or 1)
				else
					anim_speed_mult = anim_speed_mult * (weap_base._ads_anim_speed_mult or 1)
				end

				if weap_base:out_of_ammo() then
					--
				elseif weap_base.clip_empty and weap_base:clip_empty() then
					--
				elseif self._running and not self._equipped_unit:base():run_and_shoot_allowed() then
					--
				elseif weap_base._spin_up_time and weap_base._spin_up_time > 0 and not (self._windup_state > weap_base._spin_up_time) then
					--
				else
					--
					if self._shooting == true then --
						-- DP-12 animation shenanigans
						if self._equipped_unit:base()._is_dp12 then
							if self._equipped_unit:base()._dp12_needs_pump == false then
								anim_speed_mult = 0
							end
							self._equipped_unit:base():toggle_dp12_needs_pump()
						end

						--

						--local weap_tweak_data = tweak_data.weapon[weap_base:get_name_id()]
						local weap_tweak_data = self._equipped_unit:base():weapon_tweak_data() -- weaponlib
						--

						if not self._state_data.in_steelsight or not weap_base:tweak_data_anim_play("fire_steelsight", anim_speed_mult) then --
							weap_base:tweak_data_anim_play("fire", anim_speed_mult) --
						end

						if (fire_mode == "single" or weap_base._no_auto_anim == true) and weap_base:get_name_id() ~= "saw" then -- FUCKING AKIMBO BIZON ANIMS
							if not self._state_data.in_steelsight and not weap_base:weapon_tweak_data().hipfire_uses_ads_anim == true then
								self._ext_camera:play_redirect(self:get_animation("recoil"), anim_speed_mult) --
							elseif weap_tweak_data.animations.recoil_steelsight then
								self._ext_camera:play_redirect(((weap_base:is_second_sight_on() or weap_base:weapon_tweak_data().ads_uses_hipfire_anim) and self:get_animation("recoil")) or self:get_animation("recoil_steelsight"), anim_speed_mult) --
							end
						end
						--
					elseif fire_mode == "single" then
						--
					end
				end
			end
		elseif self:_is_reloading() and self._equipped_unit:base():reload_interuptable() and input.btn_primary_attack_press then
			--
		end
	end
	--
--[[
	local new_action = nil
	local action_wanted = input.btn_primary_attack_state or input.btn_primary_attack_release

	if action_wanted and not BeardLib.Utils:FindMod("irenfist") then
		local action_forbidden = self:_is_reloading() or self:_changing_weapon() or self:_is_meleeing() or self._use_item_expire_t or self:_interacting() or self:_is_throwing_projectile() or self:_is_deploying_bipod() or self._menu_closed_fire_cooldown > 0 or self:is_switching_stances()

		if not action_forbidden then
			--
			if self._equipped_unit then
				local weap_base = self._equipped_unit:base()
				local fire_mode = weap_base:fire_mode()
				local fire_on_release = weap_base:fire_on_release()

				if weap_base:out_of_ammo() then
					--
				elseif weap_base.clip_empty and weap_base:clip_empty() then
					if self:_is_using_bipod() then
						--
					elseif fire_mode == "single" then
						--
					else
						new_action = true

						--
					end
				elseif self._running and not self._equipped_unit:base():run_and_shoot_allowed() then
					--
				else
					if not self._shooting then
						if weap_base:start_shooting_allowed() then
							local start = fire_mode == "single" and input.btn_primary_attack_press
							start = start or fire_mode ~= "single" and input.btn_primary_attack_state
							start = start and not fire_on_release
							start = start or fire_on_release and input.btn_primary_attack_release

							if start then
								--

								if fire_mode == "auto" then
									self._unit:camera():play_redirect(self:get_animation("recoil_enter"), 1 * weap_base._anim_speed_mult)

									--
								end
							end
						else
							self:_check_stop_shooting()

							--
						end
					end

					--

					if self._shooting == true then --
						--

						local weap_tweak_data = self._equipped_unit:base():weapon_tweak_data() --

						--

						if not self._state_data.in_steelsight or not weap_base:tweak_data_anim_play("fire_steelsight", weap_base:fire_rate_multiplier() * weap_base._anim_speed_mult) then
							weap_base:tweak_data_anim_play("fire", weap_base:fire_rate_multiplier() * weap_base._anim_speed_mult)
						end

						if fire_mode == "single" and weap_base:get_name_id() ~= "saw" then
							if not self._state_data.in_steelsight then
								self._ext_camera:play_redirect(self:get_animation("recoil"), weap_base:fire_rate_multiplier() * weap_base._anim_speed_mult)
							elseif weap_tweak_data.animations.recoil_steelsight then
								self._ext_camera:play_redirect(weap_base:is_second_sight_on() and self:get_animation("recoil") or self:get_animation("recoil_steelsight"), 1 * weap_base._anim_speed_mult)
							end
						end

						--
					elseif fire_mode == "single" then
						--
					end
				end
			end
		elseif self:_is_reloading() and self._equipped_unit:base():reload_interuptable() and input.btn_primary_attack_press then
			--
		end
	end

	--
--]]
end)