
-- god thank you cpone

Hooks:PostHook( TweakData, "_init_pd2", "tweakdata_jesuschrist_TOO", function(self)
	local part_to_hunt = "wpn_fps_upg_i_autofire"
	log("[OAP2] Adding FCG mods to applicable weapons...")
	local function get_factory_id(weapon_id)
		for id, data in pairs(self.upgrades.definitions) do
			if data.category == "weapon" and data.weapon_id == weapon_id and data.factory_id then
				return data.factory_id
			end
		end
	end

	for weapon_id, weapon_data in pairs(self.weapon) do
		local factory_id = get_factory_id(weapon_id)

		if ( factory_id ) then
			local factory_data = self.weapon.factory[factory_id]

			if ( factory_data and factory_data.uses_parts and table.contains(factory_data.uses_parts, part_to_hunt)) then
				table.insert(factory_data.uses_parts, "wpn_fps_upg_tr_heavy")
				table.insert(factory_data.uses_parts, "wpn_fps_upg_tr_light")
				log(tostring(factory_id))
				log("...Done!")
            end
        end
    end
	log("[OAP2] Addition of FCG mods to applicable weapons completed successfully!")
end)